# workaround some rpm bug
%define _requires_exceptions statically\\|linked\\|devel(/lib/libNoVersion)

%define name	uClibc
%define version	0.9.27
%define release	3mdk

Summary:	A C library optimized for size useful for embedded applications
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	LGPL
Group:		System/Libraries
Source0:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2
Source1:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2.sign
Patch0:		uClibc-0.9.27-mdkconf.patch.bz2
URL:		http://uclibc.org/
BuildRequires:	which kernel-source
Requires:	binutils gcc-cpp
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
uClibc (pronounced yew-see-lib-see) is a C library for developing
embedded Linux systems. It is much smaller than the GNU C Library,
but nearly all applications supported by glibc also work perfectly
with uClibc. Porting applications from glibc to uClibc typically
involves just recompiling the source code. uClibc even supports
shared libraries and threading. It currently runs on standard
Linux and  MMU-less (also known as uClinux) systems with support
for alpha, ARM, cris, i386, i960, h8300, m68k, mips/mipsel,
PowerPC, SH, SPARC, and v850 processors.

If you are building an embedded Linux system and you find that
glibc is eating up too much space, you should consider using
uClibc. If you are building a huge fileserver with 12 Terabytes of
storage, then using glibc may make more sense. Unless, for
example, that 12 Terabytes will be Network Attached Storage and
you plan to burn Linux into the system's firmware...

%package	devel
Summary:	Development files for uClibc
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
Requires:	gcc

%description	devel
Small libc for building embedded applications.

%package	static-devel
Summary:	Static uClibc libratries
Group:		Development/C
Requires:	%{name}-devel = %{version}-%{release}
Provides:	libc-static

%description	static-devel
Static uClibc libratries.

%prep
%setup -q
%patch0 -p1 -b .mdkconf
find -name ".cvsignore" | xargs rm -f

%build
%ifarch %{ix86}
%define _arch i386
%endif
%ifarch armv4l
%define _arch arm
%endif
%ifarch ppc ppc64
%define _arch powerpc
%endif
%ifarch sparc sparcv9 sparc64
%define _arch sparc
%endif
perl -pi -e "s@default TARGET_.*@default TARGET_%{_arch}@" extra/Configs/Config.in

make defconfig

make
cd test
make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
make PREFIX=$RPM_BUILD_ROOT install

# convenience function
cat > %{buildroot}%{_bindir}/uclibc << EOF
#!/bin/sh
export PATH=%{_prefix}/%{_arch}-linux-uclibc%{_bindir}:\$PATH
\$@
EOF

%ifarch ppc ppc64
ln -sf ppc-linux-uclibc %{buildroot}%{_prefix}/powerpc-linux-uclibc
%endif

# these links are *needed* (by stuff in bin/)
#for f in %{buildroot}%{_prefix}/%{_arch}-linux-uclibc%{_bindir}/* ; do
#    ln -sf ../../bin/%{_arch}-uclibc-`basename $f` $f
#done

#find %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include -name CVS | xargs rm -rf

# OE: don't ship these?
rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/asm
rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/linux
rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/scsi
#(peroyvind) rpm will make these symlinks relative
ln -snf /usr/include/asm %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/asm
ln -snf /usr/include/linux %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/linux
ln -snf /usr/include/scsi %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/scsi

# at least nuke this one...
rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/usr/include/linux/modules


%clean
rm -rf %{buildroot}

%files
%defattr(644,root,root,755)
%doc README
%dir %{_prefix}/%{_arch}-linux-uclibc
%dir %{_prefix}/%{_arch}-linux-uclibc/lib
%ifnarch sparc sparcv9 sparc64
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/ld-*
%endif
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/lib*%{version}.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/lib*.so.0
%ifarch ppc
%{_prefix}/powerpc-linux-uclibc
%endif

%files devel
%defattr(644,root,root,755)
%doc docs/* docs/uclibc.org/*.html COPYING.LIB Changelog TODO
%dir %{_prefix}/%{_arch}-linux-uclibc/usr/bin
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/bin/*
%attr(755,root,root) %{_bindir}/uclibc
#%{_prefix}/%{_arch}-linux-uclibc/usr
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/crt0.o
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/crt1.o
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/crti.o
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/crtn.o
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/Scrt1.o
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/librt.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libnsl.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libpthread.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libc.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libcrypt.so
%ifnarch sparc sparcv9 sparc64
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libdl.so
%endif
%attr(2755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libm.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libresolv.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/usr/lib/libutil.so
%{_prefix}/%{_arch}-linux-uclibc/usr/include

%files static-devel
%defattr(644,root,root,755)
%{_prefix}/%{_arch}-linux-uclibc/usr/lib/lib*.a

%changelog
* Tue Mar 08 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.27-2mdk
- no multiarch, rebuild for latest multiarch-utils
- compile for i586 with optimizations
- get rid of gcc warnings

* Tue Feb 15 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.27-1mdk
- 0.9.27
- regenerate P0
- drop P1 & P2
- multiarch

* Sat Dec 25 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-5mdk
- fix problem with kernel_types.h (P2 from CVS)

* Sat Dec 25 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-4mdk
- do not ship own kernel-headers, compile against systems (less hackish:)
- require also %%{release} for subpackages
- cleanups

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-3mdk
- urg?!?!? get rid of weird dependency that came out of nowhere:(

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-2mdk
- fix paths..

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-1mdk
- 0.9.26 (with lots of suse hacks to make it build, probably needs some more tweaking..:\)

* Sat Nov 22 2003 Jean-Michel dault <jmdault@mandrakesoft.com> 0.9.21-3mdk
- compile with UCLIBC_HAS_RPC to enable nfs in busybox mount utility

* Mon Sep 22 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.21-2mdk
- rpm bug workaround

* Mon Sep 22 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.21-1mdk
- 0.9.21
- updated by Jaco Greeff <jaco@linuxminicd.org>
  - Added convenience function "uclibc", which can be used in the same
    fashion as dielibc's "diet", e.g. "uclibc make" will setup the correct
    paths for use and execute the make command
  - Updated description from website
- added P0 (jaco)
- misc spec file fixes

* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.9-2mdk
- misc spec file fixes

* Tue Sep 24 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.9-1mdk
- initial cooker contrib, ripped from PLD, adapted for ML
